<%@ Page Language="vb" Strict="True" Debug="True" %>

<script language="vb" runat="server">
    '*********************************************************************
    '*  DEMO VERSION NOTICE:
    '*  The demo version of this product contains a static barcode that may be
    '*  used for evaluation purposes only. The static barcode cannot be
    '*  changed because this would reveal the complete formula, which is only
    '*  available in the purchased version. The purchased version is provided 
    '*  with a money back satisfaction guarantee. If it is necessary to 
    '*  test dynamic barcodes with this product, the purchased version is required.
    '*  http://www.idautomation.com/barcode-components/aspx-generator-script/#licensing
    '*********************************************************************
    Sub createBarcode()
        
        Dim i As Integer, height As Integer, width As Integer, lines As String(), lines2 As String()
        Dim k as Integer , xFactor as Integer, sTemp as String 
        
        xFactor = 3
        
        height = 20
	
        lines = New String() {}
        ReDim lines(height-1)
	
        lines(19) = "10101010101010101010"
        lines(18) = "10100010101010110011"
        lines(17) = "11110111111001000110"
        lines(16) = "10001010110110101001"
        lines(15) = "11010101000011100100"
        lines(14) = "10100010101010011011"
        lines(13) = "11101101011110101100"
        lines(12) = "10001110100000011001"
        lines(11) = "11011001100001011000"
        lines(10) = "10100011000111100011"
        lines(9) = "11100100000100011110"
        lines(8) = "11011010001010001111"
        lines(7) = "10101101000111000000"
        lines(6) = "10000011101111001111"
        lines(5) = "11001111001000011010"
        lines(4) = "11000101111011010011"
        lines(3) = "11010010000111010100"
        lines(2) = "10110101101101010101"
        lines(1) = "11110001110101100010"
        lines(0) = "11111111111111111111"
        
        width = Len(lines(0))  
        
        lines2 = New String() {}
        ReDim lines2(height*xFactor - 1)
        For i = 0 To height - 1 
          sTemp = widen(lines(i), xFactor)
          For k = 0 to xFactor - 1  
            lines2((i*xFactor) + k ) = tstr(sTemp)
          Next  
        Next

        height = xFactor * height  
        width = xFactor * width  
        writeBarcode(getHeader(width, height) & Join(lines2, ""))
    End Sub

    Function widen(ByVal code As String, ByVal XDim As Integer) As String
        If XDim = 1 Then
          widen = code
        Else
          widen = Replace( Replace( code, "0", Replace( Space(XDim), " ", "0") ) , "1", Replace(Space(XDim), " ", "1") )
        End If
    End Function    
    
    
    Dim tStrCache As System.Collections.Specialized.StringDictionary = New System.Collections.Specialized.StringDictionary()

    Function tstr(ByVal data As String) As String
        If tStrCache.ContainsKey(data) Then
            tstr = tStrCache.Item(data)
            Exit Function
        End If

        
        
        Dim tchar As Integer, total As String, tpos As Integer, i As Integer, j As Integer, x As Integer
        tchar = 0
        total = ""
        tpos = 8
        For i = 1 To Len(data)
            tpos = tpos - 1
            If Mid(data, i, 1) <> "0" Then tchar = CInt(tchar + 2 ^ tpos)
            If tpos = 0 Then
                total = total & Chr(tchar)
                tpos = 8
                tchar = 0
            End If
        Next
        If tpos <> 8 Then
            total = total & Chr(tchar)
        End If
        x = Len(total) Mod 4
        If x = 0 Then x = 4
        For i = x To 3
            total = total & Chr(0)
        Next

        tStrCache.Add(data, total)
        tstr = total
    End Function

    Function size(ByVal length As Double) As String
        length = CDbl(length)
        If length > 255 Then
            If length > 65535 Then length = 65535
            size = Chr(CInt(length Mod 256)) & Chr(CInt(Int(length / 256)))
        Else
            size = Chr(CInt(length)) & Chr(0)
        End If
    End Function

    Function getHeader(ByVal width As Integer, ByVal height As Integer) As String
        getHeader = Chr(66) & Chr(77) & size(62 + (width * height)) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(62) & Chr(0) & Chr(0) & Chr(0) & Chr(40) & Chr(0) & Chr(0) & Chr(0) & size(width) & Chr(0) & Chr(0) & size(height) & Chr(0) & Chr(0) & Chr(1) & Chr(0) & Chr(1) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(37) & Chr(14) & Chr(0) & Chr(0) & Chr(37) & Chr(14) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(255) & Chr(255) & Chr(255) & Chr(0) & Chr(0) & Chr(0) & Chr(0) & Chr(0)
    End Function

    Function stb(ByVal StringArg As String) As Byte()
        Dim I As Integer, B As System.Collections.Generic.List(Of Byte) = New System.Collections.Generic.List(Of Byte)
        For I = 1 To StringArg.Length()
            B.Add(CByte(Asc(Mid(StringArg, I, 1))))
        Next
	
        stb = B.ToArray
    End Function
	    
    Sub writeBarcode(ByVal data As String)
        Response.ContentType = "image/bmp"
        Response.BinaryWrite(stb(data))
    End Sub
    
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Call createBarcode()
    End Sub
    
</script>

